clear all
clc

N = 100; % number of sensors
T = 500; % sequence length for arl ~ 5000
T1 = 200;
sigma0 = 1;
mc = 5000;
w=200;

tic
for kk = 1:mc
    W(:,1) = zeros(N,1);
    
    if ~mod(kk,100)
        disp(kk)
        
    end
    
    
    signal = randn(N,T)*sigma0; % signal with noise only
    %St = cumsum(signal,2);
    delta = 1;
    delta_n = delta; delta_n = ones(N,1)*delta;
    for t = 1:T
        
        %U = signal(:,time).*delta_n - delta_n.^2/2;
        %W(:,time) = max(0, W(:,time-1)+U);
        %stat(time) = sum(W(:, time));
        
        tt = zeros(N,1);
        for k = (t-1) : -1 : max(t-w,0)
            %for n = 1 : N
                %C(n,1) = temp(n,t-k) / square(t-k);
                %L(n,1) = temp(n,t-k)^2/square(t-k)/2;
                %L(n,1) = randn(1,1)^2/2;
                tt = tt + signal(:,k+1).*delta_n - delta_n.^2/2;
                
                %tt(n) = tt(n) + signal(n,k+1);
                %L(n,1) = tt(n)^2/(t-k)/2;
                %j = 1 : 1 : t-k;
                %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
            %end
            M(t-k,1) = max(tt);
        end
    end
    arl(kk) = max(M);
end

threshold = quantile(arl,0.9048);

