load ARL_N_100_p3_T200.mat

figure; 
plot(ARL(:,2),ARL(:,1))

b = ARL(:,2);
% calculate theoretical values
N = 100; % number of sensors
T = 100000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 100; % number of monte carlo trials
p0 = 0.3; % assumed sparsity
 
ARL_theo = zeros(length(b),1);
for i = 1 : length(b)
    ARL_theo(i) = theo_ARL_test(b(i),N,p0,w);
end

hold on;
plot(b,ARL_theo,'r-*');


xlabel('b')
ylabel('ARL')
legend('Simulation','Our Theory','Location', 'North' )
%myboldify
