load ARL_N_20_p3_T200.mat

figure; 
plot(ARL(:,2),ARL(:,1))

b = ARL(:,2);
% calculate theoretical values
N = 20; % number of sensors
T = 100000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 100; % number of monte carlo trials
p0 = 0.3; % assumed sparsity
 
ARL_theo = zeros(length(b),1);
for i = 1 : length(b)
    ARL_theo(i) = theo_ARL_two(b(i),N,p0,w);
end

hold on;
plot(b,ARL_theo,'r-*');

hold on; 
ARL_theo2 = zeros(length(b),1);
for i = 1 : length(b)
    ARL_theo2(i) = theo_ARL_old(b(i),N,p0,w);
end

hold on;
plot(b,ARL_theo2,'k--');

xlabel('b')
ylabel('ARL')
legend('Simulation','Our Theory', 'Mean Shift, Theory','Location', 'North' )
myboldify
